#include <systemctrl.h>
#include <pspkernel.h>
#include <pspsdk.h>
#include <pspge.h>
#include <pspctrl.h>
#include <pspsysclib.h>
#include <pspdisplay.h>
#include <pspsysevent.h>
#include <locale.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <pspthreadman.h>

#include "thread.h"
#include "libmenu.h"
#include "common.h"
#include "color.h"
#include "menu.h"
#include "conf.h"

PSP_MODULE_INFO("freestop", PSP_MODULE_KERNEL, 1, 1);

// inipϐ ini̍ڕKv
#define INI_PATH "/freestop.ini"
#define CONF_NUM 2
INI_Key conf[CONF_NUM];

char iniPath[128];

u32 stopkey = 0;
u32 closekey = 0;

char str[512];
static libmOpt opt;

//vOC X^bNɃACeϐu
MenuContext	Context;
static MenuItem item_list[ITEM_COUNT];

extern int view;

int volume;
int view = 0;
int beforebright;

//vg^Cv錾
int threadMain(SceSize args, void *argp);
int module_start(SceSize args, void *argp);
int module_stop(SceSize args, void *argp);
void MenuCreate();
int sceDmacplusLcdcSetBaseAddrPatched(void *baseaddr);

void MenuCreate()
{
	//j[ ACe瓮ImۂȂݒɂ
	memset(&opt,0,sizeof(opt));
	opt.type		= LIBM_OPT_LIST;
	opt.list.val	= item_list;
	opt.list.size 	= sizeof(item_list);
	
	libmSetOpt(&Context,&opt);
	
	//j[p̊ePadݒ
		
	//\ HOME
	Context.HotKey.Show				= stopkey;
	//߂ HOME
	Context.HotKey.Back				= PSP_CTRL_NOTE | PSP_CTRL_START | PSP_CTRL_LTRIGGER;
	//I ~
	Context.HotKey.Select			= closekey;
	
	// 
	Context.HotKey.Up				= PSP_CTRL_UP;
	// 
	Context.HotKey.Down				= PSP_CTRL_DOWN;
	// 
	Context.HotKey.Left				= PSP_CTRL_LEFT;
	//E
	Context.HotKey.Right				= PSP_CTRL_RIGHT;
	
	//j[^Cv́uS̕\v
	Context.MenuInfo.Type 			= LIBM_VIEW_ALL;
	//ACeŏ㕔E֗玩Ń^[
	Context.MenuInfo.AutoReturn		= true;
		
	//ANeBuȍڂ̃tHgFAwiF
	Context.Color.Active_Font		= RED;
	Context.Color.Active_Back		= BLACK;
		
	//ANeBuȍڂ̃tHgFAwiF
	Context.Color.Normal_Font		= RED;
	Context.Color.Normal_Back		= BLACK;
		
	//s
	Context.MenuInfo.Lines	= 0;
	
	MenuItem* MAIN = libmAddItem(&Context,NULL,libmCreateTriggerButton(&opt,""),Invalid,Invalid,NoAction,EXIT);

	//ANeBuACe lݒ
	libmSetActive( &Context ,MAIN);
}


int threadPrint(SceSize args, void *argp){
	while(1){
			printMenu();
		sceKernelDelayThread( 1000 );
	}
return 0;
}

//Main
int threadMain(SceSize args, void *argp)
{			
	while(1){
		if(
			sceKernelFindModuleByName("sceKernelLibrary") &&
			sceKernelFindModuleByName("sceIOFileManager") &&
			sceKernelFindModuleByName("sceController_Service") &&
			sceKernelFindModuleByName("sceDisplay_Service") &&
			sceKernelFindModuleByName("sceSystemMemoryManager")
		)
			break;

		sceKernelDelayThread(1000000);
	}
		
	SceCtrlData pad;
	MenuParams* Params;
		
	SceModule2 *mod;
	u32 display;
	mod = sceKernelFindModuleByName("sceDisplay_Service");
	if(mod != NULL)
	{
		display = GetSetBaseAddr(mod->text_addr, mod->text_addr + mod->text_size);
		if(display != 0) MAKE_CALL(display, sceDmacplusLcdcSetBaseAddrPatched);
	}

	
	//j[쐬
	MenuCreate();
	
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
				
	//nȂǂ̏ꍇ
	if(view == 0){
		SceUID print_thid = sceKernelCreateThread("PrintMenu", threadPrint, 1,0x3000, 0, NULL);
		if(threadInfo >= 0)sceKernelStartThread(print_thid, args, argp);
	}

	while( 1 )
	{
	   	sceCtrlPeekBufferPositive(&pad, 1);
		
		//Key͂nāAj[̓𒲂ׂiʂ𓾂j
		Params = libmGetHandle(&Context, &pad);
		if(Params->Action == Menu_Close)
		{	
			Suspend_Resume_Threads(1);
		}

		if (Params->Item)
		{
			switch (Params->Item->Data)
			{
				case EXIT:
				{	
					Suspend_Resume_Threads(1);
					sceDisplaySetBrightness(beforebright,0);
					Context.IsOpen = false;//Menu close
					break;
				}
			}
		}
		
		
		//0.001b҂		
		sceKernelDelayThread(1000);
	}
	
	return sceKernelExitDeleteThread( 0 );
}

void printMenu(void)
{		
		
		if(libmInitBuffers(0,PSP_DISPLAY_SETBUF_NEXTFRAME)){	
		if( libmIsOpen(&Context))
		{	
			sceDisplaySetBrightness(45,0);
			libmPrintXY(187,114,BLACK,BLACK,"...............");
			libmPrintXY(187,126,BLACK,BLACK,"...............");
			libmPrintXY(275,120,BLACK,BLACK,"..");
			libmPrintXY(187,120,BLACK,BLACK,"..");
			libmPrintXY(195,120,WHITE,BLACK,"     ~    ");
			libmRender(&Context,140,110,str,256);
			Suspend_Resume_Threads(0);
			
			sceDisplayWaitVblankStart();
			
			}
		}
	}


int sceDmacplusLcdcSetBaseAddrPatched(void *baseaddr)
{	
	int unk = 0;
	if(view == 0)view= 1;

	// ʏ̎擾
	sceDisplayGetMode(&unk, &canvas.width, &canvas.height);
	sceDisplayGetFrameBuf((void *)&canvas.buffer, &canvas.linewidth, &canvas.pixelformat, 1);

	// VRAM擾
	canvas.buffer = baseaddr;
	
	sceDisplayWaitVblankStart();
		
	return sceDmacplusLcdcSetBaseAddrReal(baseaddr);
}


int module_start(SceSize args, void *argp)
{				
	//sceDisplayGetBrightness(&beforebright,0);
		
	char *temp;

	//ǂݍinit@C̃pX
	strcpy(iniPath, argp);
	// ms0:/seplugins/foo.prxǂݍ(sꂽƂ), iniPath"ms0:/seplugins/foo.prx"Rs[
	temp = strrchr(iniPath, '/');
	// iniPatḧԌɂ '/' TÃ|C^[temp
	if( temp != NULL ) *temp = '\0';
	// temp == NULL'/'TȂƂ,܂ temp != NULL '/'TƂ
	// '/'EOS('\0')ɕςA܂iniPath"ms0:/seplugins"ƂȂ
	strcat(iniPath, INI_PATH);
	//iniPath̖"/***.ini"A܂܂iniPath"ms0:/seplugins/***.ini"ƂȂ	

	// init@C̓ǂݍ݂̉
	INI_Init_Key(conf);//(K{)

	INI_Add_Button(conf, "stopkey", &stopkey, PSP_CTRL_RTRIGGER | PSP_CTRL_LTRIGGER | PSP_CTRL_UP );
	INI_Add_Button(conf, "closekey", &closekey , PSP_CTRL_CROSS );

	// init@C̓ǂݍ
	if(INI_Read_Conf(iniPath, conf) == -1){
		// init@C֏
		INI_Write_Conf(iniPath, conf, "\r\n");//ǂݍ߂Ȃ玩ō쐬
	}

	
	// ֐̎擾
	sceDmacplusLcdcSetBaseAddrReal		= (void *)FindProc("sceLowIO_Driver", "sceDmacplus_driver", GetSetBaseAddrNidDisp());
	sceCtrlPeekBufferPositive_Real		= (void *)FindProc("sceController_Service", "sceCtrl", 0x3A622550);
	sceCtrlPeekBufferNegative_Real		= (void *)FindProc("sceController_Service", "sceCtrl", 0xC152080A);
	sceCtrlReadBufferPositive_Real		= (void *)FindProc("sceController_Service", "sceCtrl", 0x1F803938);
	sceCtrlReadBufferNegative_Real		= (void *)FindProc("sceController_Service", "sceCtrl", 0x60B81F86);


	//CXbh̃X^bNTCYACeXg̕ϐTCY ₵ĂKv
	SceUID main_thid = sceKernelCreateThread("freestop", threadMain, 16,0x3000, 0, NULL);
	if(main_thid >= 0){ 
	sceKernelStartThread(main_thid, args, argp);
	//擾XbhJn
	u32 orgaddr = FindProc("sceDisplay_Service", "sceDisplay", 0x289D82FE);
	sceDisplaySetFrameBuf_Real = (void *)orgaddr;
	sceKernelDcacheWritebackAll();
	sceKernelIcacheClearAll();
	}
	
	sceDisplayGetBrightness(&beforebright,0);
	Get_FirstThreads();

    return 0;
}


int module_stop(SceSize args, void *argp)
{
    return 0;
}

